## qtcreator 17.0.2

=== src/CMakeLists.txt ===
add_library(app_version INTERFACE)
target_include_directories(app_version
  INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  INTERFACE $<INSTALL_INTERFACE:${IDE_HEADER_INSTALL_PATH}/src>)
install(TARGETS app_version EXPORT QtCreator)

add_subdirectory(libs)
add_subdirectory(share)
add_subdirectory(shared)
add_subdirectory(plugins)
add_subdirectory(app)
add_subdirectory(tools)

install(
  FILES
    ${PROJECT_SOURCE_DIR}/HACKING
    ${PROJECT_SOURCE_DIR}/LICENSES/LICENSE.GPL3-EXCEPT
    ${PROJECT_SOURCE_DIR}/README.md
  DESTINATION ${IDE_DATA_PATH}
  COMPONENT Devel EXCLUDE_FROM_ALL
)

install(
  DIRECTORY
    ${PROJECT_SOURCE_DIR}/scripts
  DESTINATION ${IDE_DATA_PATH}
  COMPONENT Devel EXCLUDE_FROM_ALL
  USE_SOURCE_PERMISSIONS
)

install(EXPORT QtCreator
  DESTINATION ${IDE_CMAKE_INSTALL_PATH}/QtCreator
  COMPONENT Devel EXCLUDE_FROM_ALL
  NAMESPACE QtCreator::
  FILE QtCreatorTargets.cmake
)

file(WRITE ${CMAKE_BINARY_DIR}/cmake/QtCreatorConfig.cmake "
\# Qt version used for building
\# A compatible Qt version should be used by externally built plugins
set(QTC_QT_VERSION ${Qt6_VERSION})

\# force plugins to same path naming conventions as Qt Creator
\# otherwise plugins will not be found
if(UNIX AND NOT APPLE)
  include(GNUInstallDirs)
  set(CMAKE_INSTALL_BINDIR ${CMAKE_INSTALL_BINDIR})
  set(CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
  set(CMAKE_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_LIBEXECDIR})
  set(CMAKE_INSTALL_DATAROOTDIR ${CMAKE_INSTALL_DATAROOTDIR})
endif()

include(CMakeFindDependencyMacro)
find_dependency(Qt6 ${IDE_QT_VERSION_MIN}
  COMPONENTS Concurrent Core Gui Widgets Core5Compat Network PrintSupport Qml Sql REQUIRED
)
find_dependency(Qt6 COMPONENTS Quick QuickWidgets QUIET)

if (NOT IDE_VERSION)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorIDEBranding.cmake)
endif()

if (NOT DEFINED add_qtc_plugin)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorAPI.cmake)
endif()

if (NOT DEFINED add_translation_targets)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorTranslations.cmake)
endif()

if (NOT DEFINED add_qtc_documentation)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorDocumentation.cmake)
endif()

if (NOT TARGET QtCreator::Core)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorTargets.cmake)
endif()
")

# Local build export
export(EXPORT QtCreator
  NAMESPACE QtCreator::
  FILE ${CMAKE_BINARY_DIR}/cmake/QtCreatorTargets.cmake)

file(COPY
  ${IDE_BRANDING_FILE}
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorTranslations.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorDocumentation.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPI.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPIInternal.cmake
  ${PROJECT_SOURCE_DIR}/cmake/Config.cmake.in
  ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.Info.plist.in
  DESTINATION ${CMAKE_BINARY_DIR}/cmake
)

# Devel package install
install(
  FILES
    ${IDE_BRANDING_FILE}
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorTranslations.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorDocumentation.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPI.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPIInternal.cmake
    ${PROJECT_SOURCE_DIR}/cmake/Config.cmake.in
    ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.Info.plist.in
    ${CMAKE_BINARY_DIR}/cmake/QtCreatorConfig.cmake
  DESTINATION ${IDE_CMAKE_INSTALL_PATH}/QtCreator
  COMPONENT Devel EXCLUDE_FROM_ALL
)

=== src/app/CMakeLists.txt ===
configure_file(app_version.h.cmakein app_version.h ESCAPE_QUOTES)

if(NOT IS_ABSOLUTE "${IDE_ICON_PATH}")
  set(IDE_ICON_PATH "${CMAKE_CURRENT_SOURCE_DIR}/${IDE_ICON_PATH}")
endif()

if (NOT IS_ABSOLUTE ${IDE_LOGO_PATH})
  set(IDE_LOGO_PATH "${CMAKE_CURRENT_SOURCE_DIR}/${IDE_LOGO_PATH}")
endif()
configure_file(app_logo.qrc.cmakein app_logo_cmake.qrc)

add_qtc_executable(qtcreator
  DEFINES
    IDE_LIBRARY_BASENAME=\"${IDE_LIBRARY_BASE_PATH}\"
    IDE_APP_ID=\"${IDE_APP_ID}\"
  DEPENDS Aggregation ExtensionSystem Qt::Core Qt::Widgets Utils shared_qtsingleapplication app_version
  SOURCES
    main.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/app_logo_cmake.qrc
    ../tools/qtcreatorcrashhandler/crashhandlersetup.cpp ../tools/qtcreatorcrashhandler/crashhandlersetup.h
  PROPERTIES
    WIN32_EXECUTABLE ON
    MACOSX_BUNDLE ON
    OUTPUT_NAME "${IDE_APP_TARGET}"
  DESTINATION "${IDE_APP_PATH}"
  QTC_RUNNABLE
)

extend_qtc_executable(qtcreator
  CONDITION APPLE
  DEPENDS ${FWFoundation}
  SOURCES
    main_mac.mm
)

if (NOT TARGET qtcreator)
  return()
endif()

if (QTC_STATIC_BUILD)
  set(plugins_to_import "")
  set(source_file_content "#include <QtPlugin>\n")
  foreach(plugin IN LISTS __QTC_PLUGINS)
    if(TARGET ${plugin})
      list(APPEND plugins_to_import "${plugin}")
      # TODO ${plugin}Plugin is not correct for all plugins as the class name
      get_target_property(plugin_class ${plugin} QTC_PLUGIN_CLASS_NAME)
      string(APPEND source_file_content "Q_IMPORT_PLUGIN(${plugin_class})\n")
    endif()
  endforeach()

  string(APPEND source_file_content
    "struct ResourcesInitializer {\n"
    "  ResourcesInitializer() {\n")
  foreach(resource_file IN LISTS __QTC_RESOURCE_FILES)
     string(APPEND source_file_content "    Q_INIT_RESOURCE(${resource_file});\n")
  endforeach()
  string(APPEND source_file_content
    "  }\n"
    "} g_resources_initializer;\n")

  file(GENERATE
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/plugin_imports.cpp"
    CONTENT "${source_file_content}"
  )
  extend_qtc_target(qtcreator
    DEPENDS ${plugins_to_import}
    SOURCES "${CMAKE_CURRENT_BINARY_DIR}/plugin_imports.cpp"
  )

  if (TARGET QmlDesigner)
    qt6_import_qml_plugins(qtcreator
      PATH_TO_SCAN "${CMAKE_CURRENT_SOURCE_DIR}/../../share/qtcreator/qmldesigner")
  endif()
endif()

if (WIN32)
  set(RC_APPLICATION_NAME "${IDE_DISPLAY_NAME}")
  set(RC_VERSION "${IDE_VERSION}.0")
  set(RC_VERSION_STRING "${IDE_VERSION_DISPLAY}")
  set(RC_COPYRIGHT "${IDE_COPYRIGHT}")
  set(RC_PUBLISHER "${IDE_PUBLISHER}")

  string(REPLACE " " "\\x20" RC_APPLICATION_NAME "${RC_APPLICATION_NAME}")
  string(REPLACE " " "\\x20" RC_PUBLISHER "${RC_PUBLISHER}")
  string(REPLACE " " "\\x20" RC_COPYRIGHT "${RC_COPYRIGHT}")
  string(REPLACE "." "," RC_VERSION "${RC_VERSION}")

  target_compile_definitions(qtcreator PRIVATE
    RC_PUBLISHER=${RC_PUBLISHER}
    RC_APPLICATION_NAME=${RC_APPLICATION_NAME}
    RC_VERSION=${RC_VERSION}
    RC_VERSION_STRING=${RC_VERSION_STRING}
    RC_COPYRIGHT=${RC_COPYRIGHT}
    RC_ICON_PATH=${IDE_ICON_PATH}
  )

  target_sources(qtcreator PRIVATE qtcreator.rc)
endif()

if (APPLE)
  if (CMAKE_OSX_DEPLOYMENT_TARGET)
    set(MACOSX_DEPLOYMENT_TARGET ${CMAKE_OSX_DEPLOYMENT_TARGET})
  endif()
  set_target_properties(qtcreator PROPERTIES
      MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/app-Info.plist"
  )
  # icon
  add_custom_command(
    OUTPUT qtcreator.icns qtcreator-project.icns
    COMMAND
      xcrun actool --app-icon qtcreator --output-partial-info-plist "${CMAKE_CURRENT_BINARY_DIR}/qtcreator.Info.plist"
      --platform macosx --minimum-deployment-target 10.7 --compile "${CMAKE_CURRENT_BINARY_DIR}"
      "${IDE_ICON_PATH}/qtcreator.xcassets"
      > /dev/null
    BYPRODUCTS qtcreator.Info.plist
    DEPENDS
      qtcreator.xcassets/qtcreator.appiconset/Contents.json
      qtcreator.xcassets/qtcreator.appiconset/icon_128x128.png
      qtcreator.xcassets/qtcreator.appiconset/icon_128x128@2x.png
      qtcreator.xcassets/qtcreator.appiconset/icon_16x16.png
      qtcreator.xcassets/qtcreator.appiconset/icon_16x16@2x.png
      qtcreator.xcassets/qtcreator.appiconset/icon_256x256.png
      qtcreator.xcassets/qtcreator.appiconset/icon_256x256@2x.png
      qtcreator.xcassets/qtcreator.appiconset/icon_32x32.png
      qtcreator.xcassets/qtcreator.appiconset/icon_32x32@2x.png
      qtcreator.xcassets/qtcreator.appiconset/icon_512x512.png
      qtcreator.xcassets/qtcreator.appiconset/icon_512x512@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_128x128.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_128x128@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_16x16.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_16x16@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_256x256.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_256x256@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_32x32.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_32x32@2x.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_512x512.png
      qtcreator.xcassets/qtcreator-project.iconset/icon_512x512@2x.png
    VERBATIM
  )
  target_sources(qtcreator
    PRIVATE
      "${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns"
      "${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns"
  )
  qtc_copy_to_builddir(copy_icns
    DESTINATION ${IDE_DATA_PATH}
    FILES
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns
  )
  install(
    FILES
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator.icns
      ${CMAKE_CURRENT_BINARY_DIR}/qtcreator-project.icns
    DESTINATION ${IDE_DATA_PATH}
  )
endif()

option(QTC_FORCE_XCB "Enables that Qt Creator forces XCB on Linux if QT_QPA_PLATFORM is not set." OFF)
extend_qtc_executable(qtcreator
  CONDITION QTC_FORCE_XCB
  DEFINES
    QTC_FORCE_XCB
)

extend_qtc_executable(qtcreator
  CONDITION BUILD_WITH_CRASHPAD
  DEFINES
    CRASHPAD_BACKEND_URL="${CRASHPAD_BACKEND_URL}"
    ENABLE_CRASHPAD
    WIN32_LEAN_AND_MEAN # It comes usually with precompiled header, but at the installer they are disabled
  DEPENDS Crashpad::Crashpad
)
if(BUILD_WITH_CRASHPAD)
  install(
    PROGRAMS ${CRASHPAD_BIN_DIR}/crashpad_handler${CMAKE_EXECUTABLE_SUFFIX}
    DESTINATION "${IDE_LIBEXEC_PATH}"
  )
endif()

extend_qtc_executable(qtcreator
  CONDITION BUILD_WITH_SENTRY
  DEFINES
    SENTRY_DSN="${SENTRY_DSN}"
    SENTRY_PROJECT="${SENTRY_PROJECT}"
    ENABLE_SENTRY
  DEPENDS sentry::sentry
)
extend_qtc_executable(qtcreator
  CONDITION DEFINED SENTRY_CRASHPAD_PATH
  DEFINES
    SENTRY_CRASHPAD_PATH="${SENTRY_CRASHPAD_PATH}"
)

if ((NOT WIN32) AND (NOT APPLE))
  # install logo
  foreach(size 16 24 32 48 64 128 256 512)
    install(
      FILES ${IDE_LOGO_PATH}/images/logo/${size}/QtProject-${IDE_ID}.png
      DESTINATION share/icons/hicolor/${size}x${size}/apps
    )
  endforeach()
endif()

=== src/plugins/CMakeLists.txt ===
# Level 0:
add_subdirectory(coreplugin)

# Level 1: (only depends of Level 0)
add_subdirectory(lua)
add_subdirectory(texteditor)
add_subdirectory(serialterminal)
add_subdirectory(extensionmanager)
add_subdirectory(helloworld)
add_subdirectory(imageviewer)
add_subdirectory(screenrecorder)
add_subdirectory(updateinfo)
add_subdirectory(welcome)

# Level 2: (only depends on Level 1 and below)
add_subdirectory(bineditor)
add_subdirectory(cpaster)
add_subdirectory(diffeditor)
add_subdirectory(emacskeys)
add_subdirectory(macros)
add_subdirectory(projectexplorer)
add_subdirectory(silversearcher)

# Level 3: (only depends on Level 2 and below)
add_subdirectory(compilerexplorer)
add_subdirectory(cppeditor)
add_subdirectory(help)
add_subdirectory(resourceeditor)
add_subdirectory(nim)
add_subdirectory(conan)
add_subdirectory(saferenderer)
add_subdirectory(terminal)
add_subdirectory(vcpkg)
add_subdirectory(languageclient)

# Level 4: (only depends on Level 3 and below)
add_subdirectory(classview)
add_subdirectory(glsleditor)
add_subdirectory(learning)
add_subdirectory(modeleditor)
add_subdirectory(qtsupport)
add_subdirectory(todo)
add_subdirectory(vcsbase)

# Level 5:
add_subdirectory(autotoolsprojectmanager)
add_subdirectory(bazaar)
add_subdirectory(beautifier)
add_subdirectory(clearcase)
add_subdirectory(cvs)
add_subdirectory(designer)
add_subdirectory(docker)
add_subdirectory(fakevim)
add_subdirectory(fossil)
add_subdirectory(genericprojectmanager)
add_subdirectory(git)
add_subdirectory(mercurial)
add_subdirectory(mesonprojectmanager)
add_subdirectory(perforce)
add_subdirectory(qmakeprojectmanager)
add_subdirectory(qmljstools)
add_subdirectory(scxmleditor)
add_subdirectory(subversion)
add_subdirectory(compilationdatabaseprojectmanager)
if (WITH_QMLDESIGNER)
  add_subdirectory(qmldesignerbase)
endif()
add_subdirectory(webassembly)

# Level 6:
add_subdirectory(debugger)
add_subdirectory(coco)
add_subdirectory(copilot)
add_subdirectory(gitlab)
add_subdirectory(qmljseditor)
add_subdirectory(python)
add_subdirectory(clangformat)
add_subdirectory(cmakeprojectmanager)

# Level 7:
add_subdirectory(android)
add_subdirectory(autotest)
add_subdirectory(axivion)
add_subdirectory(baremetal)
add_subdirectory(clangcodemodel)
add_subdirectory(clangtools)
add_subdirectory(cppcheck)
add_subdirectory(incredibuild)
add_subdirectory(ios)
add_subdirectory(qmlprofiler)
if (WITH_QMLDESIGNER)
  add_subdirectory(qmlprojectmanager)
endif()
add_subdirectory(remotelinux)
add_subdirectory(valgrind)
add_subdirectory(perfprofiler)
add_subdirectory(qbsprojectmanager)
add_subdirectory(ctfvisualizer)
add_subdirectory(squish)
add_subdirectory(appstatisticsmonitor)

# Level 8:
add_subdirectory(qmlpreview)

# Level 9:
add_subdirectory(boot2qt)
if (WITH_QMLDESIGNER)
  unset(qmldesigner_builddir)
  if (WIN32 AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # Workaround for @CMakeFiles\QmlDesigner.rsp ld.lld.exe: The filename or extension is too long.
    # Clang on Windows is having problems with QmlDesigner.rsp which is bigger than 32KiB
    set(qmldesigner_builddir ${PROJECT_BINARY_DIR}/qmldsgnr)
  endif()
  add_subdirectory(qmldesigner ${qmldesigner_builddir})
  add_subdirectory(qmldesignerlite)
  add_subdirectory(extrapropertyeditormanager)
  add_subdirectory(effectcomposer)
  add_subdirectory(studiowelcome)
  add_subdirectory(insight)
endif()
add_subdirectory(qnx)
add_subdirectory(mcusupport)
add_subdirectory(qtapplicationmanager)

=== tests/auto/CMakeLists.txt ===
add_subdirectory(aggregation)
add_subdirectory(algorithm)
add_subdirectory(android)
add_subdirectory(changeset)
add_subdirectory(cplusplus)
add_subdirectory(debugger)
add_subdirectory(diff)
add_subdirectory(environment)
add_subdirectory(examples)
add_subdirectory(extensionsystem)
add_subdirectory(externaltool)
add_subdirectory(filesearch)
add_subdirectory(ios)
add_subdirectory(json)
add_subdirectory(languageserverprotocol)
add_subdirectory(pointeralgorithm)
add_subdirectory(profilewriter)
add_subdirectory(qml)
add_subdirectory(sdktool)
add_subdirectory(solutions)
add_subdirectory(texteditor)
add_subdirectory(toolchaincache)
add_subdirectory(tracing)
add_subdirectory(treeviewfind)
add_subdirectory(updateinfo)
add_subdirectory(utils)
add_subdirectory(valgrind)

=== src/libs/extensionsystem/CMakeLists.txt ===
add_qtc_library(ExtensionSystem
  DEPENDS Aggregation Utils
  PUBLIC_DEPENDS Qt::Core Qt::Widgets
  SOURCES
    extensionsystem_global.h
    extensionsystemtr.h
    invoker.cpp invoker.h
    iplugin.cpp iplugin.h
    optionsparser.cpp optionsparser.h
    plugindetailsview.cpp plugindetailsview.h
    pluginerroroverview.cpp pluginerroroverview.h
    pluginerrorview.cpp pluginerrorview.h
    pluginmanager.cpp pluginmanager.h pluginmanager_p.h
    pluginspec.cpp pluginspec.h
    pluginview.cpp pluginview.h
  EXPLICIT_MOC
    pluginmanager.h
  SKIP_AUTOMOC pluginmanager.cpp
)

find_package(Qt6 COMPONENTS Test QUIET)

# If ExtensionSystem was compiled with QtTest, it should provide the test options
# and the test related API, regardless if Qt Creator was compiled with tests or not,
# and regardless if an external plugin is compiled with tests or not.
# ExtensionSystem may not require QtTest in public headers though.
# API with EXTENSIONSYSTEM_TEST_EXPORT (like CppPluginSpec) should only be exported
# if Qt Creator is compiled with tests.
extend_qtc_library(ExtensionSystem
  CONDITION TARGET Qt::Test
  DEPENDS Qt::Test
  PUBLIC_DEFINES EXTENSIONSYSTEM_WITH_TESTOPTION
)

extend_qtc_library(ExtensionSystem
  CONDITION TARGET Nanotrace
  PUBLIC_DEPENDS Nanotrace
)

=== src/libs/qmleditorwidgets/CMakeLists.txt ===
add_qtc_library(QmlEditorWidgets
  DEPENDS QmlJS Utils Qt::Widgets
  SOURCES
    colorbox.cpp colorbox.h
    colorbutton.cpp colorbutton.h
    contextpanetextwidget.cpp contextpanetextwidget.h
    contextpanewidget.cpp contextpanewidget.h
    contextpanewidgetimage.cpp contextpanewidgetimage.h
    contextpanewidgetrectangle.cpp contextpanewidgetrectangle.h
    customcolordialog.cpp customcolordialog.h
    easingpane/easingcontextpane.cpp easingpane/easingcontextpane.h
    easingpane/easinggraph.cpp easingpane/easinggraph.h
    easingpane/easingpane.qrc
    filewidget.cpp filewidget.h
    fontsizespinbox.cpp fontsizespinbox.h
    gradientline.cpp gradientline.h
    huecontrol.cpp huecontrol.h
    qmleditorwidgets_global.h
    qmleditorwidgetstr.h
    resources_qmleditorwidgets.qrc
)

=== src/libs/utils/CMakeLists.txt ===
add_qtc_library(Utils
  DEPENDS Tasking Qt::Qml Qt::Xml Spinner QtCLibArchive
  PUBLIC_DEPENDS
    Qt::Concurrent Qt::Core Qt::Network Qt::Gui Qt::Widgets Qt::PrintSupport
    Qt::Core5Compat
    $<$<BOOL:${QTC_STATIC_BUILD}>:Tasking>
    $<$<BOOL:${QTC_STATIC_BUILD}>:Spinner>
  SOURCES
    ../3rdparty/span/span.hpp
    ../3rdparty/tl_expected/include/tl/expected.hpp
    action.cpp action.h
    algorithm.h
    ansiescapecodehandler.cpp ansiescapecodehandler.h
    appinfo.cpp appinfo.h
    appmainwindow.cpp appmainwindow.h
    array.h
    aspects.cpp aspects.h
    async.cpp async.h
    basetreeview.cpp basetreeview.h
    benchmarker.cpp benchmarker.h
    buildablehelperlibrary.cpp buildablehelperlibrary.h
    builderutils.h
    camelcasecursor.cpp camelcasecursor.h
    categorysortfiltermodel.cpp categorysortfiltermodel.h
    changeset.cpp changeset.h
    checkablemessagebox.cpp checkablemessagebox.h
    classnamevalidatinglineedit.cpp classnamevalidatinglineedit.h
    clangutils.cpp clangutils.h
    codegeneration.cpp codegeneration.h
    commandline.cpp commandline.h
    completinglineedit.cpp completinglineedit.h
    completingtextedit.cpp completingtextedit.h
    cpplanguage_details.h
    crumblepath.cpp crumblepath.h
    datafromprocess.h
    delegates.cpp delegates.h
    detailsbutton.cpp detailsbutton.h
    detailswidget.cpp detailswidget.h
    devicefileaccess.cpp devicefileaccess.h
    deviceshell.cpp deviceshell.h
    differ.cpp differ.h
    displayname.cpp displayname.h
    dropsupport.cpp dropsupport.h
    elfreader.cpp elfreader.h
    elidinglabel.cpp elidinglabel.h
    environment.cpp environment.h
    environmentdialog.cpp environmentdialog.h
    environmentmodel.cpp environmentmodel.h
    environmentfwd.h
    execmenu.cpp execmenu.h
    expected.h
    externalterminalprocessimpl.cpp externalterminalprocessimpl.h
    fadingindicator.cpp fadingindicator.h
    faketooltip.cpp faketooltip.h
    fancylineedit.cpp fancylineedit.h
    fancymainwindow.cpp fancymainwindow.h
    filecrumblabel.cpp filecrumblabel.h
    fileinprojectfinder.cpp fileinprojectfinder.h
    filenamevalidatinglineedit.cpp filenamevalidatinglineedit.h
    filepath.cpp filepath.h
    filepathinfo.h
    filesearch.cpp filesearch.h
    filestreamer.cpp filestreamer.h
    filestreamermanager.cpp filestreamermanager.h
    filesystemmodel.cpp filesystemmodel.h
    filesystemwatcher.cpp filesystemwatcher.h
    fileutils.cpp fileutils.h
    filewizardpage.cpp filewizardpage.h

    fsengine/fsengine.cpp fsengine/fsengine.h
    fsengine/fileiconprovider.cpp fsengine/fileiconprovider.h
    futuresynchronizer.cpp futuresynchronizer.h
    fuzzymatcher.cpp fuzzymatcher.h
    genericconstants.h
    globalfilechangeblocker.cpp globalfilechangeblocker.h
    guard.cpp guard.h
    guardedcallback.h
    guiutils.cpp guiutils.h
    headerviewstretcher.cpp headerviewstretcher.h
    highlightingitemdelegate.cpp highlightingitemdelegate.h
    historycompleter.cpp historycompleter.h
    hostosinfo.cpp hostosinfo.h
    htmldocextractor.cpp htmldocextractor.h
    icon.cpp icon.h
    icondisplay.h icondisplay.cpp
    id.cpp id.h
    indexedcontainerproxyconstiterator.h
    infobar.cpp infobar.h
    infolabel.cpp infolabel.h
    itemviews.cpp itemviews.h
    jsontreeitem.cpp jsontreeitem.h
    layoutbuilder.cpp layoutbuilder.h
    link.cpp link.h
    listmodel.h
    listutils.h
    lua.cpp lua.h
    macroexpander.cpp macroexpander.h
    markdownbrowser.cpp markdownbrowser.h
    mathutils.cpp mathutils.h
    mimeconstants.h
    mimeutils.h
    minimizableinfobars.cpp
    minimizableinfobars.h
    multitextcursor.cpp multitextcursor.h
    namevaluedictionary.cpp namevaluedictionary.h
    namevaluedictionary.cpp namevaluedictionary.h
    namevalueitem.cpp namevalueitem.h
    namevaluesdialog.cpp namevaluesdialog.h
    namevaluevalidator.cpp namevaluevalidator.h
    navigationtreeview.cpp navigationtreeview.h
    networkaccessmanager.cpp networkaccessmanager.h
    optionpushbutton.h
    optionpushbutton.cpp
    osspecificaspects.h
    outputformat.h
    outputformatter.cpp outputformatter.h
    overlaywidget.cpp overlaywidget.h
    overridecursor.cpp overridecursor.h
    passworddialog.cpp passworddialog.h
    pathchooser.cpp pathchooser.h
    pathlisteditor.cpp pathlisteditor.h
    persistentsettings.cpp persistentsettings.h
    pointeralgorithm.h
    port.cpp port.h
    portlist.cpp portlist.h
    predicates.h
    processenums.h
    processhandle.cpp processhandle.h
    processhelper.cpp processhelper.h
    processinfo.cpp processinfo.h
    processinterface.cpp processinterface.h
    processreaper.cpp processreaper.h
    progressdialog.cpp progressdialog.h
    progressindicator.cpp progressindicator.h
    projectintropage.cpp projectintropage.h
    proxyaction.cpp proxyaction.h
    qrcparser.cpp qrcparser.h
    qtcassert.cpp qtcassert.h
    qtcolorbutton.cpp qtcolorbutton.h
    qtcprocess.cpp qtcprocess.h
    qtcsettings.cpp qtcsettings.h
    qtcwidgets.cpp qtcwidgets.h
    ranges.h
    reloadpromptutils.cpp reloadpromptutils.h
    removefiledialog.cpp removefiledialog.h
    result.cpp result.h
    savefile.cpp savefile.h
    scopedswap.h
    scopedtimer.cpp scopedtimer.h
    searchresultitem.cpp searchresultitem.h
    set_algorithm.h
    settingsaccessor.cpp settingsaccessor.h
    settingsselector.cpp settingsselector.h
    shutdownguard.cpp shutdownguard.h
    sizedarray.h
    smallstring.h
    smallstringfwd.h
    smallstringio.h
    smallstringiterator.h
    smallstringlayout.h
    smallstringliteral.h
    smallstringmemory.h
    smallstringvector.h
    smallstringview.h
    sortfiltermodel.h
    span.h
    statuslabel.cpp statuslabel.h
    store.cpp store.h
    storekey.h
    stringtable.cpp stringtable.h
    stringutils.cpp stringutils.h
    styleanimator.cpp styleanimator.h
    styledbar.cpp styledbar.h
    stylehelper.cpp stylehelper.h
    summarywidget.cpp summarywidget.h
    synchronizedvalue.h
    templateengine.cpp templateengine.h
    temporarydirectory.cpp temporarydirectory.h
    temporaryfile.cpp temporaryfile.h
    terminalcommand.cpp terminalcommand.h
    terminalhooks.cpp terminalhooks.h
    terminalinterface.cpp terminalinterface.h
    textfieldcheckbox.cpp textfieldcheckbox.h
    textfieldcombobox.cpp textfieldcombobox.h
    textfileformat.cpp textfileformat.h
    textutils.cpp textutils.h
    theme/theme.cpp theme/theme.h theme/theme_p.h
    threadutils.cpp threadutils.h
    tooltip/effects.h
    tooltip/tips.cpp tooltip/tips.h
    tooltip/tooltip.cpp tooltip/tooltip.h
    touchbar/touchbar.h
    transientscroll.cpp transientscroll.h
    treemodel.cpp treemodel.h
    treeviewcombobox.cpp treeviewcombobox.h
    unarchiver.cpp unarchiver.h
    uncommentselection.cpp uncommentselection.h
    uniqueobjectptr.h
    unixutils.cpp unixutils.h
    url.cpp url.h
    utils.qrc
    utils_global.h
    utilstr.h
    utilsicons.cpp utilsicons.h
    utiltypes.h
    utility.h
    variablechooser.cpp variablechooser.h
    winutils.cpp winutils.h
    wizard.cpp wizard.h
    wizardpage.cpp wizardpage.h
    movie.cpp movie.h
)

extend_qtc_library(Utils
  SOURCES_PREFIX mimetypes2
  PUBLIC_INCLUDES mimetypes2
  SOURCES
    mimedatabase.cpp
    mimedatabase.h
    mimedatabase_p.h
    mimeglobpattern.cpp
    mimeglobpattern_p.h
    mimemagicrule.cpp
    mimemagicrule_p.h
    mimemagicrulematcher.cpp
    mimemagicrulematcher_p.h
    mimeprovider.cpp
    mimeprovider_p.h
    mimetype.cpp
    mimetype.h
    mimetype_p.h
    mimetypeparser.cpp
    mimetypeparser_p.h
    mimeutils.cpp
)

extend_qtc_library(Utils
  SOURCES_PREFIX plaintextedit
  PUBLIC_INCLUDES plaintextedit
  SOURCES
    inputcontrol.cpp
    inputcontrol.h
    plaintextedit.cpp
    plaintextedit.h
    widgettextcontrol.cpp
    widgettextcontrol.h
    plaintexteditaccessibility.cpp
    plaintexteditaccessibility.h
)

if (MSVC)
    find_library(DbgHelpLib dbghelp)
endif()

extend_qtc_library(Utils CONDITION MSVC
  DEPENDS ${DbgHelpLib}
)

extend_qtc_library(Utils CONDITION WIN32
  SOURCES
    touchbar/touchbar.cpp
  DEPENDS
    user32 iphlpapi ws2_32 shell32 ole32
  DEFINES
    _UNICODE UNICODE
  PUBLIC_DEFINES
    _CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS
)

extend_qtc_library(Utils CONDITION APPLE
  SOURCES
    fileutils_mac.mm fileutils_mac.h
    processhandle_mac.mm
    theme/theme_mac.mm theme/theme_mac.h
    touchbar/touchbar_appdelegate_mac.mm touchbar/touchbar_appdelegate_mac_p.h
    touchbar/touchbar_mac.mm touchbar/touchbar_mac_p.h
  DEPENDS
    ${FWFoundation} ${FWAppKit}
)

extend_qtc_library(Utils CONDITION UNIX AND NOT APPLE
  SOURCES
    touchbar/touchbar.cpp
)

extend_qtc_library(Utils
  CONDITION TARGET Qt::CorePrivate
  DEPENDS Qt::CorePrivate ptyqt
  DEFINES QTC_UTILS_WITH_FSENGINE
  SOURCES fsengine/diriterator.h
          fsengine/fileiteratordevicesappender.h
          fsengine/fixedlistfsengine.h
          fsengine/fsenginehandler.cpp
          fsengine/fsenginehandler.h
          fsengine/filepathinfocache.h
)

extend_qtc_library(Utils
  CONDITION TARGET Nanotrace
  DEPENDS Nanotrace
)

if (WIN32)
  add_qtc_executable(qtcreator_ctrlc_stub
    DEPENDS user32 shell32
    DEFINES _UNICODE UNICODE _CRT_SECURE_NO_WARNINGS
    SOURCES
      process_ctrlc_stub.cpp
  )
endif()

=== src/plugins/android/CMakeLists.txt ===
add_qtc_plugin(Android
  DEPENDS QmlDebug Qt::Xml LanguageServerProtocol
  PLUGIN_DEPENDS Core Debugger ProjectExplorer QtSupport LanguageClient
  LONG_DESCRIPTION_MD plugindescription.md
  LICENSE_MD LICENSE.md
  SOURCES
    androidtr.h
    androidbuildapkstep.cpp androidbuildapkstep.h
    androidconfigurations.cpp androidconfigurations.h
    androidconstants.h
    androiddebugsupport.cpp androiddebugsupport.h
    androiddeployqtstep.cpp androiddeployqtstep.h
    androiddevice.cpp androiddevice.h
    androiddeviceinfo.cpp androiddeviceinfo.h
    androidmanifesteditor.cpp androidmanifesteditor.h
    androidpackageinstallationstep.cpp androidpackageinstallationstep.h
    androidplugin.cpp
    androidqmltoolingsupport.cpp androidqmltoolingsupport.h
    androidqtversion.cpp androidqtversion.h
    androidrunconfiguration.cpp androidrunconfiguration.h
    androidrunner.cpp androidrunner.h
    androidrunnerworker.cpp androidrunnerworker.h
    androidsdkdownloader.cpp androidsdkdownloader.h
    androidsdkmanager.cpp androidsdkmanager.h
    androidsdkmanagerdialog.cpp androidsdkmanagerdialog.h
    androidsdkpackage.cpp androidsdkpackage.h
    androidsettingswidget.cpp androidsettingswidget.h
    androidsignaloperation.cpp androidsignaloperation.h
    androidtoolchain.cpp androidtoolchain.h
    androidutils.cpp androidutils.h
    avdcreatordialog.cpp avdcreatordialog.h
    avdmanageroutputparser.cpp avdmanageroutputparser.h
    javaeditor.cpp javaeditor.h
    javalanguageserver.cpp javalanguageserver.h
    javaparser.cpp javaparser.h
    keystorecertificatedialog.cpp keystorecertificatedialog.h
    manifestwizard.cpp manifestwizard.h
    splashscreencontainerwidget.cpp splashscreencontainerwidget.h
    sdkmanageroutputparser.cpp sdkmanageroutputparser.h
)

extend_qtc_plugin(Android
  CONDITION WITH_TESTS
  SOURCES
    androidsdkmanager_test.cpp androidsdkmanager_test.h
    sdkmanageroutputparser_test.cpp sdkmanageroutputparser_test.h
    android_tst.qrc
)

qtc_add_resources(Android "images"
  PREFIX "/android"
  BASE "."
  FILES
    images/androiddevice.png
    images/androiddevice@2x.png
    images/androiddevicesmall.png
    images/androiddevicesmall@2x.png
)

=== src/plugins/cmakeprojectmanager/CMakeLists.txt ===
add_qtc_plugin(CMakeProjectManager
  PLUGIN_CLASS CMakeProjectPlugin
  DEPENDS QmlJS
  PLUGIN_DEPENDS Core CppEditor Debugger ProjectExplorer TextEditor QtSupport
  SYSTEM_INCLUDES 3dparty/cmake
  SOURCES
    builddirparameters.cpp builddirparameters.h
    cmake_global.h
    cmakeabstractprocessstep.cpp cmakeabstractprocessstep.h
    cmakeautocompleter.cpp cmakeautocompleter.h
    cmakeautogenparser.cpp cmakeautogenparser.h
    cmakebuildconfiguration.cpp cmakebuildconfiguration.h
    cmakebuildsystem.cpp cmakebuildsystem.h
    cmakebuildstep.cpp cmakebuildstep.h
    cmakebuildtarget.h
    cmakeconfigitem.cpp cmakeconfigitem.h
    cmakeeditor.cpp cmakeeditor.h
    cmakefilecompletionassist.cpp cmakefilecompletionassist.h
    cmakeformatter.cpp cmakeformatter.h
    cmakeindenter.cpp cmakeindenter.h
    cmakeinstallstep.cpp cmakeinstallstep.h
    cmakekitaspect.cpp cmakekitaspect.h
    cmakelocatorfilter.cpp cmakelocatorfilter.h
    cmakeoutputparser.cpp cmakeoutputparser.h
    cmakeprocess.cpp cmakeprocess.h
    cmakeproject.cpp cmakeproject.h
    cmakeproject.qrc
    cmakeprojectconstants.h
    cmakeprojectimporter.cpp cmakeprojectimporter.h
    cmakeprojectmanager.cpp cmakeprojectmanager.h
    cmakeprojectmanagertr.h
    cmakeprojectnodes.cpp cmakeprojectnodes.h
    cmakeprojectplugin.cpp
    cmakesettingspage.cpp cmakesettingspage.h
    cmakespecificsettings.cpp cmakespecificsettings.h
    cmaketool.cpp cmaketool.h
    cmaketoolmanager.cpp cmaketoolmanager.h
    cmaketoolsettingsaccessor.cpp cmaketoolsettingsaccessor.h
    configmodel.cpp configmodel.h
    configmodelitemdelegate.cpp configmodelitemdelegate.h
    fileapidataextractor.cpp fileapidataextractor.h
    fileapiparser.cpp fileapiparser.h
    fileapireader.cpp fileapireader.h
    presetsparser.cpp presetsparser.h
    presetsmacros.cpp presetsmacros.h
    projecttreehelper.cpp projecttreehelper.h
    targethelper.cpp targethelper.h
    3rdparty/cmake/cmListFileCache.cxx
    3rdparty/cmake/cmListFileLexer.cxx
    3rdparty/cmake/cmListFileCache.h
    3rdparty/rstparser/rstparser.cc 3rdparty/rstparser/rstparser.h
)

file(GLOB_RECURSE test_cases RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} testcases/*)
qtc_add_resources(CMakeProjectManager "testcases"
  CONDITION WITH_TESTS
  PREFIX "/cmakeprojectmanager"
  BASE "."
  FILES ${test_cases}
)

=== src/plugins/conan/CMakeLists.txt ===
add_qtc_plugin(Conan
  PLUGIN_DEPENDS Core ProjectExplorer
  SOURCES
    conanconstants.h
    conaninstallstep.cpp conaninstallstep.h
    conanplugin.cpp
    conansettings.cpp conansettings.h
    conantr.h
)

=== src/plugins/docker/CMakeLists.txt ===
add_qtc_plugin(Docker
  DEPENDS Utils CmdBridgeClient
  PLUGIN_DEPENDS Core ProjectExplorer QtSupport
  SOURCES
    docker_global.h
    dockertr.h
    dockerapi.cpp dockerapi.h
    dockerconstants.h
    dockercontainerthread.cpp
    dockercontainerthread.h
    dockerdevice.cpp dockerdevice.h
    dockerdevicewidget.cpp dockerdevicewidget.h
    dockerdeviceenvironmentaspect.cpp dockerdeviceenvironmentaspect.h
    dockerplugin.cpp
    dockersettings.cpp dockersettings.h
    kitdetector.cpp kitdetector.h
)

=== src/plugins/extrapropertyeditormanager/CMakeLists.txt ===
add_qtc_plugin(ExtraPropertyEditorManager
  CONDITION TARGET QtCreator::QmlDesigner AND NOT QTC_USE_QML_DESIGNER_LITE
  PLUGIN_DEPENDS
    QtCreator::QmlDesigner
  DEPENDS
    Qt::Core Qt::CorePrivate QtCreator::Utils
  SOURCES
    extrapropertyeditormanagerplugin.cpp
    extrapropertyeditormanagerplugin.h
    extrapropertyeditorview.cpp
    extrapropertyeditorview.h
)

=== debian/changelog ===
qtcreator (17.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Wed, 01 Oct 2025 19:51:01 +0200

qtcreator (17.0.1-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release:
    - supports Qt 6.9+ (Closes: #1115520)
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Restore proper changelog entry.
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Tue, 23 Sep 2025 19:47:37 +0200

=== debian/control ===
Source: qtcreator
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adam Majer <adamm@zombino.com>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: clang (>= 1:14~),
               clangd (>= 1:17~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               libarchive-dev,
               libclang-dev (>= 1:14~),
               libdw-dev,
               libsecret-1-dev,
               libyaml-cpp-dev (>= 0.5~),
               libzstd-dev,
               llvm-dev (>= 1:14~),
               pkgconf,
               python3:any,
               qt6-5compat-dev (>= 6.5.4~),
               qt6-base-dev (>= 6.7.3~),
               qt6-base-private-dev (>= 6.5.4~),
               qt6-charts-dev (>= 6.5.4~),
               qt6-declarative-dev (>= 6.5.4~),
               qt6-declarative-private-dev (>= 6.5.4~),
               qt6-quick3d-dev (>= 6.5.4~),
               qt6-quick3d-private-dev (>= 6.5.4~),
               qt6-quicktimeline-dev (>= 6.5.4~),
               qt6-serialport-dev (>= 6.5.4~),
               qt6-shadertools-dev (>= 6.5.4~),
               qt6-svg-dev (>= 6.5.4~),
               qt6-tools-dev (>= 6.5.4~),
               qt6-tools-private-dev (>= 6.5.4~),
               qt6-websockets-dev (>= 6.5.4~),
               xxd,
               zlib1g-dev,
Standards-Version: 4.7.2
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qtcreator

Package: qtcreator
Architecture: any
Depends: clangd (>= 1:17~),
         libqt6sql6-sqlite,
         qml6-module-qtqml-models,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qml-qt6,
            qt6-qmltooling-plugins,
            qt6-base-dev-tools,
            qtcreator-doc,
            qt6-declarative-dev-tools,
            qt6-tools-dev-tools,
            qt6-translations-l10n,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5), cmake, g++, git, meson, subversion, valgrind,
          python3-pylsp,
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: qt6-image-formats-plugins,
         ${misc:Depends},
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.

=== debian/watch ===
version=4
opts="uversionmangle=s/-beta/~beta/;s/-rc/~rc/" \
https://download.qt.io/official_releases/qtcreator/([\d\.]*)/([-a-z\d\.]*)/qt-creator-opensource-src-([-a-z\d\.]*)\.tar\.xz

## qtcreator 18.0.0~beta1

=== debian/changelog ===
qtcreator (18.0.0~beta1-1) experimental; urgency=medium

  * New upstream development release.
  * Switch watch file to the unstable releases.
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update the build dependencies according to the upstream build system:
    - drop qt6-5compat-dev, no more needed

 -- Pino Toscano <pino@debian.org>  Thu, 25 Sep 2025 05:30:16 +0200

## qtcreator 18.0.0~beta2

=== src/plugins/valgrind/CMakeLists.txt ===
add_qtc_plugin(Valgrind
  DEPENDS CPlusPlus
  PLUGIN_DEPENDS Core Debugger ProjectExplorer TextEditor
  SOURCES
    callgrind/callgrindabstractmodel.h
    callgrind/callgrindcallmodel.cpp callgrind/callgrindcallmodel.h
    callgrind/callgrindcostitem.cpp callgrind/callgrindcostitem.h
    callgrind/callgrindcycledetection.cpp callgrind/callgrindcycledetection.h
    callgrind/callgrinddatamodel.cpp callgrind/callgrinddatamodel.h
    callgrind/callgrindfunction.cpp callgrind/callgrindfunction.h callgrind/callgrindfunction_p.h
    callgrind/callgrindfunctioncall.cpp callgrind/callgrindfunctioncall.h
    callgrind/callgrindfunctioncycle.cpp callgrind/callgrindfunctioncycle.h
    callgrind/callgrindparsedata.cpp callgrind/callgrindparsedata.h
    callgrind/callgrindparser.cpp callgrind/callgrindparser.h
    callgrind/callgrindproxymodel.cpp callgrind/callgrindproxymodel.h
    callgrind/callgrindstackbrowser.cpp callgrind/callgrindstackbrowser.h
    callgrindcostdelegate.cpp callgrindcostdelegate.h
    callgrindcostview.cpp callgrindcostview.h
    callgrindhelper.cpp callgrindhelper.h
    callgrindnamedelegate.cpp callgrindnamedelegate.h
    callgrindtextmark.cpp callgrindtextmark.h
    callgrindtool.cpp callgrindtool.h
    callgrindvisualisation.cpp callgrindvisualisation.h
    memcheckerrorview.cpp memcheckerrorview.h
    memchecktool.cpp memchecktool.h
    startremotedialog.cpp startremotedialog.h
    valgrind.qrc
    valgrindplugin.cpp
    valgrindprocess.cpp valgrindprocess.h
    valgrindsettings.cpp valgrindsettings.h
    valgrindtr.h
    valgrindutils.cpp valgrindutils.h
    xmlprotocol/announcethread.cpp xmlprotocol/announcethread.h
    xmlprotocol/error.cpp xmlprotocol/error.h
    xmlprotocol/errorlistmodel.cpp xmlprotocol/errorlistmodel.h
    xmlprotocol/frame.cpp xmlprotocol/frame.h
    xmlprotocol/parser.cpp xmlprotocol/parser.h
    xmlprotocol/stack.cpp xmlprotocol/stack.h
    xmlprotocol/stackmodel.cpp xmlprotocol/stackmodel.h
    xmlprotocol/status.cpp xmlprotocol/status.h
    xmlprotocol/suppression.cpp xmlprotocol/suppression.h
)

extend_qtc_plugin(Valgrind
  CONDITION WIN32
  DEFINES UNICODE _UNICODE
)

extend_qtc_plugin(Valgrind
  CONDITION WITH_TESTS
  SOURCES
    valgrindmemcheckparsertest.cpp valgrindmemcheckparsertest.h
    valgrindtestrunnertest.cpp valgrindtestrunnertest.h
  DEFINES
    PARSERTESTS_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/unit_testdata"
    VALGRIND_FAKE_PATH="${PROJECT_BINARY_DIR}/src/tools/valgrindfake"
    TESTRUNNER_SRC_DIR="${PROJECT_SOURCE_DIR}/tests/auto/valgrind/memcheck/testapps"
    TESTRUNNER_APP_DIR="${PROJECT_BINARY_DIR}/tests/auto/valgrind/memcheck/testapps"
)

=== src/tools/buildoutputparser/CMakeLists.txt ===
add_qtc_executable(buildoutputparser
  DEPENDS Utils ProjectExplorer QtSupport QmakeProjectManager
  SOURCES
    main.cpp
    outputprocessor.cpp outputprocessor.h
)

=== src/tools/disclaim/CMakeLists.txt ===
set(IMPLICIT_DEPENDS) # never build against QtTest
add_qtc_executable(disclaim
  SOURCES
    disclaim.mm
)

=== src/tools/qtcdebugger/CMakeLists.txt ===
if (NOT WIN32)
  return()
endif()

add_qtc_executable(qtcdebugger
  DEPENDS Qt::Widgets registryaccess psapi app_version
  SOURCES
    main.cpp
  PROPERTIES WIN32_EXECUTABLE ON
)

=== tests/auto/updateinfo/CMakeLists.txt ===
add_qtc_test(tst_updateinfo
  INCLUDES ${PROJECT_SOURCE_DIR}/src/plugins
  DEPENDS Utils Qt::Xml
  SOURCES tst_updateinfo.cpp
)

=== tests/manual/genericproject/Makefile ===
CC      := g++
FLAGS   :=
FILES   := $(shell find . -name '*.cpp' -o -name '*.h')
DESTNAME:= generic

.PHONY: all clean

TARGETS := Generic

all: $(TARGETS)

clean:
	find . -type f -name '*.o' -delete
	rm -rf .obj
	rm -f generic

$(TARGETS):
	$(CC) $(FLAGS) $(FILES) -o $(DESTNAME)

=== src/libs/3rdparty/cplusplus/CMakeLists.txt ===
add_qtc_library(3rd_cplusplus OBJECT
  PUBLIC_DEPENDS Qt::Core Utils
  SOURCES
    AST.cpp AST.h
    ASTClone.cpp
    ASTMatch0.cpp
    ASTMatcher.cpp ASTMatcher.h
    ASTPatternBuilder.h
    ASTVisit.cpp
    ASTVisitor.cpp ASTVisitor.h
    ASTfwd.h
    Bind.cpp Bind.h
    CPlusPlus.h
    CPlusPlusForwardDeclarations.h
    Control.cpp Control.h
    CoreTypes.cpp CoreTypes.h
    DiagnosticClient.cpp DiagnosticClient.h
    FullySpecifiedType.cpp FullySpecifiedType.h
    Keywords.cpp
    Lexer.cpp Lexer.h
    LiteralTable.h
    Literals.cpp Literals.h
    Matcher.cpp Matcher.h
    MemoryPool.cpp MemoryPool.h
    Name.cpp Name.h
    NameVisitor.cpp NameVisitor.h
    Names.cpp Names.h
    ObjectiveCAtKeywords.cpp
    ObjectiveCTypeQualifiers.cpp ObjectiveCTypeQualifiers.h
    Parser.cpp Parser.h
    QtContextKeywords.cpp QtContextKeywords.h
    SafeMatcher.cpp SafeMatcher.h
    Scope.cpp Scope.h
    Symbol.cpp Symbol.h
    SymbolVisitor.h
    Symbols.cpp Symbols.h
    Templates.cpp Templates.h
    Token.cpp Token.h
    TranslationUnit.cpp TranslationUnit.h
    Type.cpp Type.h
    TypeVisitor.cpp TypeVisitor.h
    cppassert.h
  SKIP_PCH
  SBOM_ARGS
    SBOM_ENTITY_TYPE THIRD_PARTY_LIBRARY_WITH_FILES
    USE_ATTRIBUTION_FILES
    ATTRIBUTION_FILE_PATHS
      "${QtCreator_SOURCE_DIR}/qt_attributions.json"
    ATTRIBUTION_IDS
      front-end-for-cpp
)

set(export_symbol_declaration DEFINES CPLUSPLUS_BUILD_LIB)
if (QTC_STATIC_BUILD)
  set(export_symbol_declaration PUBLIC_DEFINES CPLUSPLUS_BUILD_STATIC_LIB)
endif()
extend_qtc_target(3rd_cplusplus ${export_symbol_declaration})

if(TARGET 3rd_cplusplus)
  qtc_enable_release_for_debug_configuration()
  if (BUILD_WITH_PCH)
    target_precompile_headers(3rd_cplusplus PRIVATE
      "${QtCreator_SOURCE_DIR}/src/shared/qtcreator_gui_pch.h")
  endif()

  if(UNIX)
    target_compile_options(3rd_cplusplus PRIVATE "-Wno-unused-variable")
  endif()
endif()

=== src/libs/3rdparty/libvterm/CMakeLists.txt ===
add_qtc_library(libvterm STATIC
  PUBLIC_INCLUDES ${CMAKE_CURRENT_SOURCE_DIR}/include
  PROPERTIES QT_COMPILE_OPTIONS_DISABLE_WARNINGS ON
  SOURCES
    src/encoding.c
    src/fullwidth.inc
    src/keyboard.c
    src/mouse.c
    src/parser.c
    src/pen.c
    src/rect.h
    src/screen.c
    src/state.c
    src/unicode.c
    src/utf8.h
    src/vterm.c
    src/vterm_internal.h
  SBOM_ARGS
    SBOM_ENTITY_TYPE THIRD_PARTY_LIBRARY_WITH_FILES
    USE_ATTRIBUTION_FILES
    ATTRIBUTION_FILE_PATHS
      "${QtCreator_SOURCE_DIR}/qt_attributions.json"
    ATTRIBUTION_IDS
      libvterm
)

=== src/libs/gocmdbridge/server/CMakeLists.txt ===
set(ALL_CMDBRIDGE_PLATFORMS "")

function(go_build NAME SOURCES PLATFORMS ARCHITECTURES LDFLAGS)
    qtc_output_binary_dir(_output_binary_dir)
    set(OUTPUT_FOLDER "${_output_binary_dir}/${IDE_LIBEXEC_PATH}")
    foreach(ARCHITECTURE ${ARCHITECTURES})
        foreach(PLATFORM ${PLATFORMS})
            set(TARGET_NAME ${NAME}-${PLATFORM}-${ARCHITECTURE})
            set(OUTPUT ${OUTPUT_FOLDER}/${TARGET_NAME})

            if (${PLATFORM} STREQUAL "windows")
                string(APPEND OUTPUT ".exe")
            endif()

            if ((${PLATFORM} STREQUAL "linux" OR (${PLATFORM} STREQUAL "windows" AND ${ARCHITECTURE} STREQUAL "amd64")) AND NOT UPX_BIN STREQUAL "UPX_BIN-NOTFOUND")
                add_custom_command(
                    OUTPUT "${OUTPUT}"
                    COMMAND ${CMAKE_COMMAND} -E env GOARCH=${ARCHITECTURE} GOOS=${PLATFORM} CGO_ENABLED=0 ${GO_BIN} build -ldflags "-s -w ${LDFLAGS}" -o ${OUTPUT}
                    COMMAND ${UPX_BIN} -9 ${OUTPUT}
                    DEPENDS ${SOURCES}
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                    COMMENT "Building ${TARGET_NAME}"
                    VERBATIM

                )
            else()
                add_custom_command(
                    OUTPUT "${OUTPUT}"
                    COMMAND ${CMAKE_COMMAND} -E env GOARCH=${ARCHITECTURE} GOOS=${PLATFORM} CGO_ENABLED=0 ${GO_BIN} build -ldflags "-s -w ${LDFLAGS}" -o ${OUTPUT}
                    DEPENDS ${SOURCES}
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                    COMMENT "Building ${TARGET_NAME}"
                    VERBATIM
                )
            endif()

            install(PROGRAMS ${OUTPUT} DESTINATION "${IDE_LIBEXEC_PATH}")

            list(APPEND ALL_CMDBRIDGE_PLATFORMS "${OUTPUT}")
        endforeach()
    endforeach()
    set(ALL_CMDBRIDGE_PLATFORMS ${ALL_CMDBRIDGE_PLATFORMS} PARENT_SCOPE)
endfunction()

find_program(GO_BIN go)
find_program(UPX_BIN upx)

if (${GO_BIN} STREQUAL "GO_BIN-NOTFOUND")
    set(CMDBRIDGEFEATURE NO)
    set(CMDBRIDGEFEATURE_TEXT "no GO compiler found")
else ()
    set(CMDBRIDGEFEATURE YES)
    set(CMDBRIDGEFEATURE_TEXT "with GO compiler at ${GO_BIN}")

    set(SOURCE_FILES
        channelwriter.go
        cmdbridge.go
        exec.go
        fileaccess_windows.go
        fileaccess.go
        find.go
        is.go
        readfile.go
        stat.go
        writefile.go
        watcher.go
    )

    go_build(cmdbridge "${SOURCE_FILES}" "linux;darwin;windows" "amd64;arm64" "-X main.MagicPacketMarker=${GOBRIDGE_MAGIC_PACKET_MARKER}")

    add_custom_target(CmdBridge
      DEPENDS
        ${ALL_CMDBRIDGE_PLATFORMS}
      SOURCES
        ${SOURCE_FILES}
    )
endif()

add_feature_info("Executable CmdBridge" ${CMDBRIDGEFEATURE} ${CMDBRIDGEFEATURE_TEXT})

=== src/libs/solutions/tasking/CMakeLists.txt ===
add_qtc_library(Tasking
# Never add dependencies to non-Qt libraries for this library
  DEPENDS Qt::Concurrent Qt::Core Qt::Network
  SOURCES
    barrier.cpp
    barrier.h
    concurrentcall.h
    conditional.cpp
    conditional.h
    networkquery.cpp
    networkquery.h
    qprocesstask.cpp
    qprocesstask.h
    tasking_global.h
    tasktree.cpp
    tasktree.h
    tasktreerunner.cpp
    tasktreerunner.h
    tcpsocket.cpp
    tcpsocket.h
)

=== src/shared/qbs/tests/CMakeLists.txt ===
add_subdirectory(auto)
add_subdirectory(benchmarker)
add_subdirectory(clang-format-test)
add_subdirectory(fuzzy-test)
add_subdirectory(lspclient)

=== tests/auto/cplusplus/semantic/CMakeLists.txt ===
add_qtc_test(tst_cplusplus_semantic
  DEPENDS CppEditor
  SOURCES tst_semantic.cpp
)

=== debian/changelog ===
qtcreator (18.0.0~beta2-1) experimental; urgency=medium

  * New upstream development release.
  * Merge changes from 17.0.2-1.

 -- Pino Toscano <pino@debian.org>  Thu, 02 Oct 2025 21:27:44 +0200

=== debian/watch ===
version=4
opts="uversionmangle=s/-beta/~beta/;s/-rc/~rc/" \
https://download.qt.io/development_releases/qtcreator/([\d\.]*)/([-a-z\d\.]*)/qt-creator-opensource-src-([-a-z\d\.]*)\.tar\.xz
